﻿#pragma strict

//Vocal SFXs
var positiveA : AudioClip;
var positiveB : AudioClip;
var positiveC : AudioClip;
var negitiveA : AudioClip;
var negitiveB : AudioClip;
var negitiveC : AudioClip;

//Phases
var instructions : GameObject;
var instructions2 : GameObject;
var startButton : GameObject;
var scoreScreen : GameObject;

static var score : int;
static var popUpScoreValue : int;
var popUpTextObject : GameObject;

static var gasLevel : float;
static var gameStatus : String;
static var itemsOnBbq : int = 0;
static var maxItemsOnBbq : int = 4;

//Positions on Grill
static var posOne : String;
static var posTwo : String;
static var posThree : String;
static var posFour : String;
static var lastPosFilled : String;

//SFXs
var badFoodSfx : AudioClip;
var goodFoodSfx : AudioClip;
var perfectFoodSfx : AudioClip;

private var gasOn : boolean;

//Selected Meat Values
static var selectedMeatType : String = "";
static var selectedMeatValue : String = "";
static var selectedOrderType : int;


function Start()
{
	score = 0;
	lastPosFilled = "";
	posOne = "Free";
	posTwo = "Free";
	posThree = "Free";
	posFour = "Free";
	gasOn = false;
	gasLevel = 100;
	gameStatus = "Instructions";
}

function Update()
{
	if (gameStatus == "Waiting for Start")
		startButton.active = true;
	else
		startButton.active = false;
	
	if (gameStatus == "Instructions")
		instructions.active = true;
	else
		instructions.active = false;
	
	if (gameStatus == "Instructions2")
		instructions2.active = true;
	else
		instructions2.active = false;
		
	if (gameStatus == "Game Over")
	{
		scoreScreen.active = true;
		posOne = "Free";
		posTwo = "Free";
		posThree = "Free";
		posFour = "Free";
	}
	else
		scoreScreen.active = false;
	
	//print("Score: " + score + "..... Position 1: " + posOne + "..... Position 2: " + posTwo + "..... Position 3: " + posThree + "..... Position 4: " + posFour);
	
	CalculateScore();
	
	if (gameStatus == "Running")
	{
		gasLevel -= (Time.deltaTime);
		
		if (!gasOn)
		{
			audio.Play();
			gasOn = true;
		}
	}
	
	if (gasLevel <= 0)
	{
		gasLevel = 0;
		audio.Stop();
		gasOn = false;
		gameStatus = "Game Over";
	}
	
	
}


function CalculateScore()
{
	if (selectedMeatType != "" && selectedMeatType != "Remove" && selectedOrderType != 0)
	{
		//CALCULATE SCORE
		if (selectedMeatType == "Steak")
		{
			if (selectedMeatValue == "Burnt" || selectedMeatValue == "Raw")
			{
				score += 0;
				audio.PlayOneShot(negitiveB);
				popUpScoreValue = -1;
				Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));
			}
			else if (selectedOrderType == 1)//Steak Rare
			{
				if (selectedMeatValue == "Rare")
					{audio.PlayOneShot(positiveA); score += 10; popUpScoreValue = 10; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
				if (selectedMeatValue == "Medium Rare")
					{audio.PlayOneShot(positiveC); score += 8; popUpScoreValue = 8; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
				if (selectedMeatValue == "Medium")
					{audio.PlayOneShot(positiveB); score += 6; popUpScoreValue = 6; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
				if (selectedMeatValue == "Medium Well Done")
					{audio.PlayOneShot(positiveB); score += 4; popUpScoreValue = 4; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
				if (selectedMeatValue == "Well Done")
					{audio.PlayOneShot(positiveB); score += 2; popUpScoreValue = 2; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
			}
			else if (selectedOrderType == 2)//Steak Medium Rare
			{
				if (selectedMeatValue == "Rare")
					{audio.PlayOneShot(positiveC); score += 8; popUpScoreValue = 8; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
				if (selectedMeatValue == "Medium Rare")
					{audio.PlayOneShot(positiveA); score += 12; popUpScoreValue = 12; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
				if (selectedMeatValue == "Medium")
					{audio.PlayOneShot(positiveC); score += 8; popUpScoreValue = 8; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
				if (selectedMeatValue == "Medium Well Done")
					{audio.PlayOneShot(positiveB); score += 6; popUpScoreValue = 6; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
				if (selectedMeatValue == "Well Done")
					{audio.PlayOneShot(positiveB); score += 4; popUpScoreValue = 4; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
			}
			else if (selectedOrderType == 3)//Steak Medium
			{
				if (selectedMeatValue == "Rare")
					{audio.PlayOneShot(positiveB); score += 6; popUpScoreValue = 6; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
				if (selectedMeatValue == "Medium Rare")
					{audio.PlayOneShot(positiveC); score += 8; popUpScoreValue = 8; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
				if (selectedMeatValue == "Medium")
					{audio.PlayOneShot(positiveA); score += 14; popUpScoreValue = 14; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
				if (selectedMeatValue == "Medium Well Done")
					{audio.PlayOneShot(positiveC); score += 8; popUpScoreValue = 8; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
				if (selectedMeatValue == "Well Done")
					{audio.PlayOneShot(positiveB); score += 6; popUpScoreValue = 6; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
			}
			else if (selectedOrderType == 4)//Steak Medium Well Done
			{
				if (selectedMeatValue == "Rare")
					{audio.PlayOneShot(positiveB); score += 4; popUpScoreValue = 4; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
				if (selectedMeatValue == "Medium Rare")
					{audio.PlayOneShot(positiveB); score += 6; popUpScoreValue = 6; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
				if (selectedMeatValue == "Medium")
					{audio.PlayOneShot(positiveC); score += 8; popUpScoreValue = 8; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
				if (selectedMeatValue == "Medium Well Done")
					{audio.PlayOneShot(positiveA); score += 16; popUpScoreValue = 16; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
				if (selectedMeatValue == "Well Done")
					{audio.PlayOneShot(positiveC); score += 8; popUpScoreValue = 8; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
			}
			else if (selectedOrderType == 5)//Steak Well Done
			{
				if (selectedMeatValue == "Rare")
					{audio.PlayOneShot(positiveB); score += 2; popUpScoreValue = 2; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
				if (selectedMeatValue == "Medium Rare")
					{audio.PlayOneShot(positiveB); score += 4; popUpScoreValue = 4; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
				if (selectedMeatValue == "Medium")
					{audio.PlayOneShot(positiveB); score += 6; popUpScoreValue = 6; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
				if (selectedMeatValue == "Medium Well Done")
					{audio.PlayOneShot(positiveC); score += 8; popUpScoreValue = 8; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
				if (selectedMeatValue == "Well Done")
					{audio.PlayOneShot(positiveA); score += 20; popUpScoreValue = 20; Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));}
			}
			else if (selectedOrderType == 6)//Paddy
			{
				score += 0;
				audio.PlayOneShot(negitiveC);
				popUpScoreValue = -1;
				Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));
			}
		}
		else if (selectedMeatType == "Paddy")
		{
			if (selectedOrderType != 6)//Paddy
			{
				score += 0;
				audio.PlayOneShot(negitiveA);
				popUpScoreValue = -1;
				Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));
			}
			else if (selectedOrderType == 6)//Paddy
			{
				if (selectedMeatValue == "Burnt" || selectedMeatValue == "Raw")
				{
					score += 0;
					audio.PlayOneShot(negitiveB);
					popUpScoreValue = -1;
					Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));
				}
				else
				{
					score += 15;
					audio.PlayOneShot(positiveC);
					popUpScoreValue = 15;
					Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));
				}
			}
		}
		else if (selectedMeatType == "Sausages")
		{
			if (selectedOrderType != 7)//Sausages
			{
				score += 0;
				audio.PlayOneShot(negitiveA);
				popUpScoreValue = -1;
				Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));
			}
			else if (selectedOrderType == 7)//Sausages
			{
				if (selectedMeatValue == "Burnt" || selectedMeatValue == "Raw")
				{
					score += 0;
					audio.PlayOneShot(negitiveC);
					popUpScoreValue = -1;
					Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));
				}
				else
				{
					score += 10;
					audio.PlayOneShot(positiveC);
					popUpScoreValue = 10;
					Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));
				}
			}
		}
		else if (selectedMeatType == "Bacon")
		{
			if (selectedOrderType != 8)//Bacon
			{
				score += 0;
				audio.PlayOneShot(negitiveB);
				popUpScoreValue = -1;
				Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));
			}
			else if (selectedOrderType == 8)//Bacon
			{
				if (selectedMeatValue == "Burnt" || selectedMeatValue == "Raw")
				{
					score += 0;
					audio.PlayOneShot(negitiveA);
					popUpScoreValue = -1;
					Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));
				}
				else
				{
					score += 20;
					audio.PlayOneShot(positiveA);
					popUpScoreValue = 20;
					Instantiate(popUpTextObject, Vector3 (0, 3, -3.8), (Quaternion.AngleAxis(0, Vector3.down)));
				}
			}
		}
		
		if (posOne == "Selected")
			posOne = "Free";
		
		if (posTwo == "Selected")
			posTwo = "Free";
			
		if (posThree == "Selected")
			posThree = "Free";
			
		if (posFour == "Selected")
			posFour = "Free";
		
		selectedMeatType = "Remove";
		selectedMeatValue = "";
		selectedOrderType = 0;
	}
}

@script RequireComponent(AudioSource)