﻿#pragma strict

var raw : Texture2D;
var rare : Texture2D;
var mediumRare : Texture2D;
var medium : Texture2D;
var mediumWellDone : Texture2D;
var wellDone : Texture2D;
var overDone : Texture2D;
var burnt : Texture2D;

private var foodPos : String;
private var cookingTimer : float = 0;
private var meatValue : String;
private var currentMeatSelected : boolean = false;
var spatula : GameObject;

function OnMouseOver(){
    if(Input.GetMouseButtonDown(0) && GameScript.gameStatus == "Running")
    {
		if (foodPos == "One" && GameScript.posOne == "Not Free" && GameScript.posTwo != "Selected" && GameScript.posThree != "Selected" && GameScript.posFour != "Selected")
		{
			currentMeatSelected = true;
			GameScript.posOne = "Selected";
			SendSelectedMeatData();
		}
		else if (foodPos == "Two" && GameScript.posOne != "Selected" && GameScript.posTwo == "Not Free" && GameScript.posThree != "Selected" && GameScript.posFour != "Selected")
		{
			currentMeatSelected = true;
			GameScript.posTwo = "Selected";
			SendSelectedMeatData();
		}
		else if (foodPos == "Three" && GameScript.posOne != "Selected" && GameScript.posTwo != "Selected" && GameScript.posThree == "Not Free" && GameScript.posFour != "Selected")
		{
			currentMeatSelected = true;
			GameScript.posThree = "Selected";
			SendSelectedMeatData();
		}
		else if (foodPos == "Four" && GameScript.posOne != "Selected" && GameScript.posTwo != "Selected" && GameScript.posThree != "Selected" && GameScript.posFour == "Not Free")
		{
			currentMeatSelected = true;
			GameScript.posFour = "Selected";
			SendSelectedMeatData();
		}
    }
}

function SendSelectedMeatData()
{
	GameScript.selectedMeatType = "Steak";
	GameScript.selectedMeatValue = meatValue;
}

function Start()
{
	foodPos = GameScript.lastPosFilled;
}

function Update()
{
	if (currentMeatSelected)
		spatula.active = true;
	else
		spatula.active = false;
	
	if (currentMeatSelected && GameScript.selectedMeatType == "Remove" || GameScript.gameStatus == "Instructions" || GameScript.gameStatus == "Game Over")
	{
		GameScript.selectedMeatType = "";
		GameScript.itemsOnBbq -= 1;
		Destroy (gameObject);
	}

	if (GameScript.gameStatus == "Running" && !currentMeatSelected)
	{
		cookingTimer += Time.deltaTime;
		
		if (cookingTimer <= 3)
		{
			renderer.material.mainTexture = raw;
			meatValue = "Raw";
		}
		
		if (cookingTimer > 3 && cookingTimer < 6)
		{
			renderer.material.mainTexture = rare;
			meatValue = "Rare";
		}
		
		if (cookingTimer > 6 && cookingTimer < 9)
		{
			renderer.material.mainTexture = mediumRare;
			meatValue = "Medium Rare";
		}
		
		if (cookingTimer > 9 && cookingTimer < 12)
		{
			renderer.material.mainTexture = medium;
			meatValue = "Medium";
		}
		
		if (cookingTimer > 12 && cookingTimer < 14)
		{
			renderer.material.mainTexture = mediumWellDone;
			meatValue = "Medium Well Done";
		}
		
		if (cookingTimer > 14 && cookingTimer < 16)
		{
			renderer.material.mainTexture = wellDone;
			meatValue = "Well Done";
		}
		
		if (cookingTimer > 16 && cookingTimer < 18)
		{
			renderer.material.mainTexture = overDone;
			meatValue = "Over Done";
		}
		
		if (cookingTimer > 18)
		{
			renderer.material.mainTexture = burnt;
			meatValue = "Burnt";
		}
	}
}

@script RequireComponent(AudioSource)